//
// tiny.h
//
// header file for tiny basic
//

#ifndef TINY__H
#define TINY__H

#define BYTE_POKE		0
#define WORD_POKE		1
#define LONG_POKE		2

typedef struct BUCKET {
	struct BUCKET *next;
	struct BUCKET **prev;
}BUCKET;

class hashtab {
	int tabsize;
	int numsyms;
	BUCKET **table;
	unsigned hash(unsigned char *name);
public:
	hashtab(int size);
	~hashtab();
	void *newsym(int size);
	void *addsym(void *isym);
	void *findsym(char *isym);
	void delsym(void *isym);
	void *nextsym(void *ilast);
	void dump(FILE *o);
};

struct string {
	int size;
	char *s;
};

#define SYMBOLTYPE_LONG			1
#define SYMBOLTYPE_TEMPLONG		2
#define SYMBOLTYPE_DOUBLE		3
#define SYMBOLTYPE_TEMPDOUBLE	4
#define SYMBOLTYPE_STRING		5
#define SYMBOLTYPE_TEMPSTRING	6

class symbol {
	char name[32];
	int type;
public:
	union{
		long lv;
		double dv;
	}value;
	char *sv;
	symbol *next;
	symbol(char *s);	//constructor
	~symbol();			//destructor
	void Init(void);	//fake constructor
	void SetVal(long v);
	long GetLongVal(void);
	void SetVal(double v);
	double GetDoubleVal(void);
	void SetName(char *s);
	void PrintInfo(FILE *o);
	void SetType(int t);
	int GetType(void);
	void SetVal(symbol *v);
	char *GetStringVal(void);
	int GetStringLen(void);
	void SetMaxStringLen(long d);
	void SetVal(char *s);
};

struct FOR_STACK {
	char *start;	/*	start of loop	*/
	long count;
	long step;
	symbol *loopvar;
};

struct SubroutineStack {
	char *return_line;
	char *laptr;
    int ssx,sn;
};

struct ExpressionList {
	symbol *v;
	ExpressionList *next;
	ExpressionList(){next = NULL;}
};

#endif


